#drinc:util.g
#drinc:Disassemble.g

uint
    R_D0 = 0,
    R_D1 = 1,
    R_A0 = 0,
    R_FP = 6,

    OP_MOVEB = 0x1000,
    OP_MOVEL = 0x2000,

    M_DDIR = 0,
    M_ADIR = 1,
    M_DISP = 5;

ulong StartAddress, EndAddress;
*bool LabelArray;
bool PassOne;

proc readWord(/* ulong address */)uint:
    ulong address;

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	address
    );
    if address < EndAddress then
	pretend(address, *uint)*
    else
	0
    fi
corp;

proc putChar(/* char ch*/)void:
    char ch;

    code(
	OP_MOVEB | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	ch
    );
    if not PassOne then
	if ch = '\n' then
	    writeln();
	else
	    write(ch);
	fi;
    fi;
corp;

proc findLabel1(register ulong addr)*char:
    extern
	findLabel()*char,
	findAbsSymbol(ulong addr, refAt; *ulong pTrueAddr)*char,
	findRelSymbol(long offset; ulong refAt)*char,
	branchTo(ulong addr)void,
	isLabel(ulong addr)bool,
	main()void;

    if addr = pretend(readWord, ulong) then
	"readWord"
    elif addr = pretend(putChar, ulong) then
	"putChar"
    elif addr = pretend(findLabel1, ulong) then
	"findLabel1"
    elif addr = pretend(findLabel, ulong) then
	"findLabel"
    elif addr = pretend(findAbsSymbol, ulong) then
	"findAbsSymbol"
    elif addr = pretend(findRelSymbol, ulong) then
	"findRelSymbol"
    elif addr = pretend(branchTo, ulong) then
	"branchTo"
    elif addr = pretend(isLabel, ulong) then
	"isLabel"
    elif addr = pretend(main, ulong) then
	"main"
    else
	nil
    fi
corp;

proc findLabel(/* register ulong addr */)*char:
    ulong address;

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	address
    );
    findLabel1(address)
corp;

proc findAbsSymbol(/* register ulong addr, refAt; *ulong pTrueAddr */)*char:
    register ulong addr, refAt;
    *ulong pTrueAddr;
    ulong address, refAddress;
    register *char label;

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	address,
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D1,
	refAddress,
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_ADIR << 3 | R_A0,
	pTrueAddr
    );
    addr := address;
    refAt := refAddress;
    pTrueAddr* := addr;
    label := findLabel1(addr);
    if label ~= nil then
	label
    elif addr = pretend(&StartAddress, ulong) then
	"StartAddress"
    elif addr = pretend(&EndAddress, ulong) then
	"EndAddress"
    elif addr = pretend(&LabelArray, ulong) then
	"LabelArray"
    elif addr = pretend(&PassOne, ulong) then
	"PassOne"
    else
	nil
    fi
corp;

proc findRelSymbol(/* register long offset; register ulong refAt */)*char:
    long offset;
    ulong refAt;

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	offset,
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D1,
	refAt
    );
    findLabel1(refAt + offset)
corp;

proc branchTo(/* ulong addr */)void:
    ulong addr;

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	addr
    );
    if addr >= StartAddress and addr < EndAddress then
	(LabelArray + addr - StartAddress)* := true;
    fi;
corp;

proc isLabel(/* ulong addr */)bool:
    ulong addr;

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	addr
    );
    if addr >= StartAddress and addr < EndAddress then
	(LabelArray + addr - StartAddress)*
    else
	false
    fi
corp;

proc main()void:
    extern tail()void;
    DisassemblerState_t ds;
    register ulong i;
    register *bool p;

    if OpenDisassembleLibrary(0) ~= nil then
	StartAddress := pretend(readWord, ulong);
	EndAddress := pretend(tail, ulong);
	i := EndAddress - StartAddress;
	LabelArray := Malloc(i);
	if LabelArray = nil then
	    writeln("Can't allocate LabelArray");
	else
	    p := LabelArray;
	    while i ~= 0 do
		i := i - 1;
		p* := false;
		p := p + sizeof(bool);
	    od;
	    ds.ds_readWord := readWord;
	    ds.ds_putChar := putChar;
	    ds.ds_findLabel := nil;
	    ds.ds_findAbsSymbol := nil;
	    ds.ds_findRelSymbol := nil;
	    ds.ds_branchTo := branchTo;
	    ds.ds_isLabel := nil;
	    ds.ds_address := StartAddress;
	    ds.ds_relativeBase := 0;
	    ds.ds_operandColumn := 20;
	    ds.ds_putCodeAddress := false;
	    ds.ds_relativeAddress := true;
	    ds.ds_putErrors := true;
	    ds.ds_capExtended := true;
	    ds.ds_putAddress := false;
	    ds.ds_putRelForm := false;
	    PassOne := true;
	    while ds.ds_address < EndAddress do
		ignore Disassemble(&ds);
	    od;
	    PassOne := false;
	    ds.ds_findLabel := findLabel;
	    ds.ds_findAbsSymbol := findAbsSymbol;
	    ds.ds_findRelSymbol := findRelSymbol;
	    ds.ds_branchTo := nil;
	    ds.ds_isLabel := isLabel;
	    ds.ds_address := StartAddress;
	    ds.ds_relativeBase := 0;
	    while ds.ds_address < EndAddress do
		ignore Disassemble(&ds);
	    od;
	    Mfree(LabelArray, EndAddress - StartAddress);
	fi;
	CloseDisassembleLibrary();
    else
	writeln("Can't open Disassemble.library");
    fi;
corp;

proc tail()void:
corp;
