/*
 * Constructs.g - definitions for use with a parser and interpreter to handle
 *	a standard set of language constructs.
 */

type
    IfPart_t = struct {
	*IfPart_t ifp_next;
	*ExpressionNode_t ifp_condition;
	*ExpressionNode_t ifp_statement;
    },

    IfNode_t = struct {
	*IfPart_t ifn_alternatives;
	*ExpressionNode_t ifn_else;
    },

    WhileNode_t = struct {
	*ExpressionNode_t whn_condition;
	*ExpressionNode_t whn_body;
    },

    ForNode_t = struct {
	*ExpressionNode_t forn_variable;
	*ExpressionNode_t forn_init;
	*ExpressionNode_t forn_step;
	*ExpressionNode_t forn_final;
	*ExpressionNode_t forn_statement;
	bool forn_isUpto;
    },

    CaseList_t = struct {
	*CaseList_t csl_next;
	ulong csl_value;
    },

    AlternativeList_t = struct {
	*AlternativeList_t alt_next;
	*CaseList_t alt_indexes;
	*ExpressionNode_t alt_statement;
    },

    CaseNode_t = struct {
	*AlternativeList_t casen_alternatives;
	*ExpressionNode_t casen_default;
    },

    FormatList_t = struct {
	*FormatList_t fml_next;
	*ExpressionNode_t fml_expression;
	*ExpressionNode_t fml_fieldLength;
	*ExpressionNode_t fml_fieldPrecision;
	char fml_format;
    },

    IOStatement_t = struct {
	*ExpressionNode_t ios_channel;
	*FormatList_t ios_expressions;
	bool ios_isRead, ios_isLine;
    };
