/*
 * NodeTypes.g - define the standard node-types that are handled by the
 *	basic language.
 */

uint
    exp_ushortToUint		= 0,
    exp_shortToInt		= exp_ushortToUint + 1,
    exp_uintToUlong		= exp_shortToInt + 1,
    exp_intToLong		= exp_uintToUlong + 1,
    exp_ulongToUint		= exp_intToLong + 1,
    exp_longToInt		= exp_ulongToUint + 1,
    exp_uintToUshort		= exp_longToInt + 1,
    exp_intToShort		= exp_uintToUshort + 1,

    exp_longUnPlus		= exp_intToShort + 1,
    exp_longNegate		= exp_longUnPlus + 1,
    exp_longAbs 		= exp_longNegate + 1,
    exp_longPlus		= exp_longAbs + 1,
    exp_longMinus		= exp_longPlus + 1,
    exp_longTimes		= exp_longMinus + 1,
    exp_longDivide		= exp_longTimes + 1,
    exp_longRemainder		= exp_longDivide + 1,
    exp_longNot 		= exp_longRemainder + 1,
    exp_longAnd 		= exp_longNot + 1,
    exp_longOr			= exp_longAnd + 1,
    exp_longXor 		= exp_longOr + 1,
    exp_longLessThan		= exp_longXor + 1,
    exp_longLessOrEqual 	= exp_longLessThan + 1,
    exp_longGreaterThan 	= exp_longLessOrEqual + 1,
    exp_longGreaterOrEqual	= exp_longGreaterThan + 1,
    exp_longEqual		= exp_longGreaterOrEqual + 1,
    exp_longNotEqual		= exp_longEqual + 1,
    exp_longAssign		= exp_longNotEqual + 1,

    exp_ulongUnPlus		= exp_longAssign + 1,
    exp_ulongNegate		= exp_ulongUnPlus + 1,
    exp_ulongAbs		= exp_ulongNegate + 1,
    exp_ulongPlus		= exp_ulongAbs + 1,
    exp_ulongMinus		= exp_ulongPlus + 1,
    exp_ulongTimes		= exp_ulongMinus + 1,
    exp_ulongDivide		= exp_ulongTimes + 1,
    exp_ulongRemainder		= exp_ulongDivide + 1,
    exp_ulongNot		= exp_ulongRemainder + 1,
    exp_ulongAnd		= exp_ulongNot + 1,
    exp_ulongOr 		= exp_ulongAnd + 1,
    exp_ulongXor		= exp_ulongOr + 1,
    exp_ulongShiftLeft		= exp_ulongXor + 1,
    exp_ulongShiftRight 	= exp_ulongShiftLeft + 1,
    exp_ulongLessThan		= exp_ulongShiftRight + 1,
    exp_ulongLessOrEqual	= exp_ulongLessThan + 1,
    exp_ulongGreaterThan	= exp_ulongLessOrEqual + 1,
    exp_ulongGreaterOrEqual	= exp_ulongGreaterThan + 1,
    exp_ulongEqual		= exp_ulongGreaterOrEqual + 1,
    exp_ulongNotEqual		= exp_ulongEqual + 1,
    exp_ulongAssign		= exp_ulongNotEqual + 1,

    exp_intUnPlus		= exp_ulongAssign + 1,
    exp_intNegate		= exp_intUnPlus + 1,
    exp_intAbs			= exp_intNegate + 1,
    exp_intPlus 		= exp_intAbs + 1,
    exp_intMinus		= exp_intPlus + 1,
    exp_intTimes		= exp_intMinus + 1,
    exp_intDivide		= exp_intTimes + 1,
    exp_intRemainder		= exp_intDivide + 1,
    exp_intNot			= exp_intRemainder + 1,
    exp_intAnd			= exp_intNot + 1,
    exp_intOr			= exp_intAnd + 1,
    exp_intXor			= exp_intOr + 1,
    exp_intLessThan		= exp_intXor + 1,
    exp_intLessOrEqual		= exp_intLessThan + 1,
    exp_intGreaterThan		= exp_intLessOrEqual + 1,
    exp_intGreaterOrEqual	= exp_intGreaterThan + 1,
    exp_intEqual		= exp_intGreaterOrEqual + 1,
    exp_intNotEqual		= exp_intEqual + 1,
    exp_intAssign		= exp_intNotEqual + 1,

    exp_uintUnPlus		= exp_intAssign + 1,
    exp_uintNegate		= exp_uintUnPlus + 1,
    exp_uintAbs 		= exp_uintNegate + 1,
    exp_uintPlus		= exp_uintAbs + 1,
    exp_uintMinus		= exp_uintPlus + 1,
    exp_uintTimes		= exp_uintMinus + 1,
    exp_uintDivide		= exp_uintTimes + 1,
    exp_uintRemainder		= exp_uintDivide + 1,
    exp_uintNot 		= exp_uintRemainder + 1,
    exp_uintAnd 		= exp_uintNot + 1,
    exp_uintOr			= exp_uintAnd + 1,
    exp_uintXor 		= exp_uintOr + 1,
    exp_uintShiftLeft		= exp_uintXor + 1,
    exp_uintShiftRight		= exp_uintShiftLeft + 1,
    exp_uintLessThan		= exp_uintShiftRight + 1,
    exp_uintLessOrEqual 	= exp_uintLessThan + 1,
    exp_uintGreaterThan 	= exp_uintLessOrEqual + 1,
    exp_uintGreaterOrEqual	= exp_uintGreaterThan + 1,
    exp_uintEqual		= exp_uintGreaterOrEqual + 1,
    exp_uintNotEqual		= exp_uintEqual + 1,
    exp_uintAssign		= exp_uintNotEqual + 1,

    exp_shortUnPlus		= exp_uintAssign + 1,
    exp_shortNegate		= exp_shortUnPlus + 1,
    exp_shortAbs		= exp_shortNegate + 1,
    exp_shortPlus		= exp_shortAbs + 1,
    exp_shortMinus		= exp_shortPlus + 1,
    exp_shortTimes		= exp_shortMinus + 1,
    exp_shortDivide		= exp_shortTimes + 1,
    exp_shortRemainder		= exp_shortDivide + 1,
    exp_shortNot		= exp_shortRemainder + 1,
    exp_shortAnd		= exp_shortNot + 1,
    exp_shortOr 		= exp_shortAnd + 1,
    exp_shortXor		= exp_shortOr + 1,
    exp_shortLessThan		= exp_shortXor + 1,
    exp_shortLessOrEqual	= exp_shortLessThan + 1,
    exp_shortGreaterThan	= exp_shortLessOrEqual + 1,
    exp_shortGreaterOrEqual	= exp_shortGreaterThan + 1,
    exp_shortEqual		= exp_shortGreaterOrEqual + 1,
    exp_shortNotEqual		= exp_shortEqual + 1,
    exp_shortAssign		= exp_shortNotEqual + 1,

    exp_ushortUnPlus		= exp_shortAssign + 1,
    exp_ushortNegate		= exp_ushortUnPlus + 1,
    exp_ushortAbs		= exp_ushortNegate + 1,
    exp_ushortPlus		= exp_ushortAbs + 1,
    exp_ushortMinus		= exp_ushortPlus + 1,
    exp_ushortTimes		= exp_ushortMinus + 1,
    exp_ushortDivide		= exp_ushortTimes + 1,
    exp_ushortRemainder 	= exp_ushortDivide + 1,
    exp_ushortNot		= exp_ushortRemainder + 1,
    exp_ushortAnd		= exp_ushortNot + 1,
    exp_ushortOr		= exp_ushortAnd + 1,
    exp_ushortXor		= exp_ushortOr + 1,
    exp_ushortShiftLeft 	= exp_ushortXor + 1,
    exp_ushortShiftRight	= exp_ushortShiftLeft + 1,
    exp_ushortLessThan		= exp_ushortShiftRight + 1,
    exp_ushortLessOrEqual	= exp_ushortLessThan + 1,
    exp_ushortGreaterThan	= exp_ushortLessOrEqual + 1,
    exp_ushortGreaterOrEqual	= exp_ushortGreaterThan + 1,
    exp_ushortEqual		= exp_ushortGreaterOrEqual + 1,
    exp_ushortNotEqual		= exp_ushortEqual + 1,
    exp_ushortAssign		= exp_ushortNotEqual + 1,

    exp_floatUnPlus		= exp_ushortAssign + 1,
    exp_floatNegate		= exp_floatUnPlus + 1,
    exp_floatAbs		= exp_floatNegate + 1,
    exp_floatPlus		= exp_floatAbs + 1,
    exp_floatMinus		= exp_floatPlus + 1,
    exp_floatTimes		= exp_floatMinus + 1,
    exp_floatDivide		= exp_floatTimes + 1,
    exp_floatLessThan		= exp_floatDivide + 1,
    exp_floatLessOrEqual	= exp_floatLessThan + 1,
    exp_floatGreaterThan	= exp_floatLessOrEqual + 1,
    exp_floatGreaterOrEqual	= exp_floatGreaterThan + 1,
    exp_floatEqual		= exp_floatGreaterOrEqual + 1,
    exp_floatNotEqual		= exp_floatEqual + 1,
    exp_floatAssign		= exp_floatNotEqual + 1,

    exp_charPlus		= exp_floatAssign + 1,
    exp_charMinus		= exp_charPlus + 1,
    exp_charLessThan		= exp_charMinus + 1,
    exp_charLessOrEqual 	= exp_charLessThan + 1,
    exp_charGreaterThan 	= exp_charLessOrEqual + 1,
    exp_charGreaterOrEqual	= exp_charGreaterThan + 1,
    exp_charEqual		= exp_charGreaterOrEqual + 1,
    exp_charNotEqual		= exp_charEqual + 1,
    exp_charAssign		= exp_charNotEqual + 1,

    exp_stringLessThan		= exp_charAssign + 1,
    exp_stringLessOrEqual	= exp_stringLessThan + 1,
    exp_stringGreaterThan	= exp_stringLessOrEqual + 1,
    exp_stringGreaterOrEqual	= exp_stringGreaterThan + 1,
    exp_stringEqual		= exp_stringGreaterOrEqual + 1,
    exp_stringNotEqual		= exp_stringEqual + 1,
    exp_stringAssign		= exp_stringNotEqual + 1,

    exp_boolNot 		= exp_stringAssign + 1,
    exp_boolAnd 		= exp_boolNot + 1,
    exp_boolOr			= exp_boolAnd + 1,
    exp_boolEqual		= exp_boolOr + 1,
    exp_boolNotEqual		= exp_boolEqual + 1,
    exp_boolAssign		= exp_boolNotEqual + 1,

    exp_error			= exp_boolAssign + 1,

    con_if			= exp_error + 1,
    con_while			= con_if + 1,
    con_for			= con_while + 1,
    con_case			= con_for + 1,
    con_read			= con_case + 1,
    con_write			= con_read + 1,
    con_ioerror 		= con_write + 1,
    con_make			= con_ioerror + 1,
    con_pretend 		= con_make + 1,
    con_error			= con_pretend + 1;
