#drinc:util.g
#/Src/Lex.g
#/Src/LexStandard.g

#//Print/Src/Print.g

bool
    SHOW_RESULT = false,
    DEFINE_EXTRA = true ,
    UNDEFINE_SOME = false,
    UNDEFINE_ALL = false;

[STANDARD_RESERVED_WORD_COUNT + 5] ReservedWord_t ReservedWords;
[STANDARD_OPERATOR_COUNT + 5] Operator_t Operators;

TokenizerState_t TokenizerState;
PrintState_t PrintState;
uint Line, Column, PrevLine, PrevColumn;

proc getChar()char:
    char ch;

    PrevLine := Line;
    PrevColumn := Column;
    if not read(ch) then
	if ioerror() = CH_EOF then
	    ch := '\e';
	else
	    readln();
	    ch := '\n';
	    Column := 0;
	    Line := Line + 1;
	fi;
    else
	if ch = '\t' then
	    Column := (Column + 8) & (-8);
	else
	    Column := Column + 1;
	fi;
    fi;
    ch
corp;

proc err(*char message)void:

    writeln("Line ", PrevLine, ", column ", PrevColumn, " *** ", message);
corp;

proc getExpression()ulong:

    GetNextToken(&TokenizerState);
    case TokenizerState.tk_kind
    incase tk_ulong:
	TokenizerState.tk_ulongValue
    incase tk_char:
	TokenizerState.tk_charValue - '\e'
    default:
	err("illegal escaped character expression");
	0
    esac
corp;

proc doubleBuffer(*TokenizerState_t tk)bool:
    *char newBuffer;

    newBuffer := Malloc(tk*.tk_bufferLength * 2);
    if newBuffer = nil then
	false
    else
	BlockCopy(newBuffer, tk*.tk_buffer, tk*.tk_bufferPosition);
	Mfree(tk*.tk_buffer, tk*.tk_bufferLength);
	tk*.tk_buffer := newBuffer;
	tk*.tk_bufferLength := tk*.tk_bufferLength * 2;
	true
    fi
corp;

proc putChar(char ch)void:

    write(ch);
corp;

proc putString(*char st)void:

    write(st);
corp;

proc main()void:
    type PAIR = [2] char;
    register *TokenizerState_t tk;
    register *PrintState_t prs;
    register *Operator_t op;
    *ReservedWord_t rw @ op;
    register uint cnt;

    if OpenlexLibrary(0) = nil then
	return;
    fi;
    MerrorSet(true);

    tk := &TokenizerState;
    tk*.tk_getChar := getChar;
    tk*.tk_getExpression := getExpression;
    tk*.tk_stringError := err;
    tk*.tk_doubleBuffer := doubleBuffer;
    tk*.tk_reservedWords := &ReservedWords[0];
    tk*.tk_operators := &Operators[0];

    tk*.tk_buffer := Malloc(1000);
    if tk*.tk_buffer = nil then
	return;
    fi;
    tk*.tk_bufferLength := 1000;

    LexStandard(tk);
    if DEFINE_EXTRA then
	LexInsertOperator(tk, 1000, PAIR('+', '+'));
	LexInsertOperator(tk, 1001, PAIR('=', '='));
	LexInsertOperator(tk, 1002, PAIR('-', '>'));
	LexInsertOperator(tk, 1003, PAIR('!', ' '));
	LexInsertOperator(tk, 1004, PAIR('!', '='));
	tk*.tk_characterClass['!'] := cc_operator;
	LexInsertReservedWord(tk, 1010, "newone");
	LexInsertReservedWord(tk, 1011, "newtwo");
	LexInsertReservedWord(tk, 1012, "begin");
	LexInsertReservedWord(tk, 1013, "end");
	LexInsertReservedWord(tk, 1014, "static");
    fi;

    if UNDEFINE_SOME then
	LexDeleteOperator(tk, tk_openBrace);
	LexDeleteOperator(tk, tk_closeBrace);
	LexDeleteOperator(tk, tk_assign);
	LexDeleteOperator(tk, tk_bitxor);
	LexDeleteOperator(tk, tk_shiftLeft);
	LexDeleteOperator(tk, tk_dollar);
	LexDeleteReservedWord(tk, tk_elif);
	LexDeleteReservedWord(tk, tk_chip);
	LexDeleteReservedWord(tk, tk_writeln);
	LexDeleteReservedWord(tk, tk_and);
    fi;

    if UNDEFINE_ALL then
	for cnt from 0 upto 1000 do
	    LexDeleteOperator(tk, cnt);
	    LexDeleteReservedWord(tk, cnt);
	od;
    fi;

    if SHOW_RESULT then
	op := tk*.tk_operators;
	cnt := tk*.tk_operatorCount;
	while cnt ~= 0 do
	    cnt := cnt - 1;
	    writeln(op*.op_code, ' ', op*.op_text[0], op*.op_text[1]);
	    op := op + sizeof(Operator_t);
	od;
	rw := tk*.tk_reservedWords;
	cnt := tk*.tk_reservedWordCount;
	while cnt ~= 0 do
	    cnt := cnt - 1;
	    writeln(rw*.rw_code, ' ', rw*.rw_text);
	    rw := rw + sizeof(ReservedWord_t);
	od;
    fi;

    prs := &PrintState;
    prs*.prs_putChar := putChar;
    prs*.prs_putString := putString;
    prs*.prs_tk := tk;

    PrevLine := 1;
    Line := 1;
    PrevColumn := 0;
    Column := 0;
    while
	GetNextToken(tk);
	tk*.tk_kind ~= tk_endOfFile
    do
	case tk*.tk_kind
	incase tk_illegal:
	    err("illegal characters");
	incase tk_ulongConst:
	    writeln("ULONG: ", tk*.tk_ulongValue);
	incase tk_floatConst:
	    writeln("FLOAT");
	incase tk_stringConst:
	    writeln("STRING \"", tk*.tk_buffer, "\"");
	incase tk_id:
	    writeln("ID ", tk*.tk_buffer);
	incase tk_charConst:
	    write("CHAR \'");
	    PrintChar(prs, tk*.tk_charValue);
	    writeln('\'');
	incase tk_newLine:
	    writeln("NEWLINE");
	incase tk_comment:
	    writeln("COMMENT>>", tk*.tk_buffer, "<<");
	default:
	    write("Token code ", tk*.tk_kind, ": ");
	    PrintToken(prs, tk*.tk_kind);
	    writeln();
	esac;
    od;

    Mfree(tk*.tk_buffer, tk*.tk_bufferLength);
    CloselexLibrary();
corp;
