#drinc:util.g
#/Src/Lex.g
#/Src/LexStandard.g

/*
#/Src/ascii.g
*/

/*
uint RESERVED_WORD_COUNT = 29;
[RESERVED_WORD_COUNT] ReservedWord_t ReservedWords := (
    ("binary" , 100),
    ("case"   , 101),
    ("channel", 102),
    ("corp"   , 103),
    ("default", 104),
    ("do"     , 105),
    ("downto" , 106),
    ("elif"   , 107),
    ("else"   , 108),
    ("esac"   , 109),
    ("fi"     , 110),
    ("for"    , 111),
    ("from"   , 112),
    ("if"     , 113),
    ("incase" , 114),
    ("input"  , 115),
    ("ioerror", 116),
    ("od"     , 117),
    ("output" , 118),
    ("proc"   , 119),
    ("read"   , 120),
    ("readln" , 121),
    ("step"   , 122),
    ("text"   , 123),
    ("then"   , 124),
    ("upto"   , 125),
    ("while"  , 126),
    ("write"  , 127),
    ("writeln", 128)
);

uint OPERATOR_COUNT = 29;
[OPERATOR_COUNT] Operator_t Operators := (
    (('\#', '\#'), 10),
    ((':', '='), 11),
    (('>', '<'), 12),
    (('<', '<'), 13),
    (('>', '>'), 14),
    (('<', '='), 15),
    (('>', '='), 16),
    (('~', '='), 17),
    (('+', ' '), 18),
    (('-', ' '), 19),
    (('*', ' '), 20),
    (('/', ' '), 21),
    (('%', ' '), 22),
    (('=', ' '), 23),
    (('<', ' '), 24),
    (('>', ' '), 25),
    (('~', ' '), 26),
    (('&', ' '), 27),
    (('|', ' '), 28),
    ((',', ' '), 29),
    (('.', ' '), 30),
    ((';', ' '), 31),
    ((':', ' '), 32),
    (('(', ' '), 33),
    ((')', ' '), 34),
    (('[', ' '), 35),
    ((']', ' '), 36),
    (('{', ' '), 37),
    (('}', ' '), 38)
);
*/

[STANDARD_RESERVED_WORD_COUNT] ReservedWord_t ReservedWords;
[STANDARD_OPERATOR_COUNT] Operator_t Operators;

TokenizerState_t TokenizerState;
uint Line, Column, PrevLine, PrevColumn;

proc getChar()char:
    char ch;

    PrevLine := Line;
    PrevColumn := Column;
    if not read(ch) then
	if ioerror() = CH_EOF then
	    ch := '\e';
	else
	    readln();
	    ch := '\n';
	    Column := 0;
	    Line := Line + 1;
	fi;
    else
	if ch = '\t' then
	    Column := (Column + 8) & (-8);
	else
	    Column := Column + 1;
	fi;
    fi;
    ch
corp;

proc err(*char message)void:

    writeln("Line ", PrevLine, ", column ", PrevColumn, " *** ", message);
corp;

proc getExpression()ulong:

    GetNextToken(&TokenizerState);
    case TokenizerState.tk_kind
    incase tk_ulong:
	TokenizerState.tk_ulongValue
    incase tk_char:
	TokenizerState.tk_charValue - '\e'
    default:
	err("illegal escaped character expression");
	0
    esac
corp;

proc doubleBuffer(*TokenizerState_t tk)bool:
    *char newBuffer;

    newBuffer := Malloc(tk*.tk_bufferLength * 2);
    if newBuffer = nil then
	false
    else
	BlockCopy(newBuffer, tk*.tk_buffer, tk*.tk_bufferPosition);
	Mfree(tk*.tk_buffer, tk*.tk_bufferLength);
	tk*.tk_buffer := newBuffer;
	tk*.tk_bufferLength := tk*.tk_bufferLength * 2;
	true
    fi
corp;

proc main()void:
    type PAIR = [2] char;
    register *TokenizerState_t tk;

    if OpenlexLibrary(0) = nil then
	return;
    fi;
    MerrorSet(true);

    tk := &TokenizerState;
    tk*.tk_getChar := getChar;
    tk*.tk_getExpression := getExpression;
    tk*.tk_stringError := err;
    tk*.tk_doubleBuffer := doubleBuffer;
    tk*.tk_reservedWords := &ReservedWords[0];
    tk*.tk_operators := &Operators[0];

/*
    tk*.tk_reservedWordCount := RESERVED_WORD_COUNT;
    tk*.tk_operatorCount := OPERATOR_COUNT;
    tk*.tk_characterClass := ASCII_MAP;
    tk*.tk_lineComment := PAIR('-', '-');
    tk*.tk_commentStart := PAIR('/', '*');
    tk*.tk_commentEnd := PAIR('*', '/');
    tk*.tk_stringEscape := '\\';
    tk*.tk_commentsNest := true;
    tk*.tk_stringBreakAllowed := true;
    tk*.tk_reportNewLines := false;
    tk*.tk_preserveComments := false;
*/

    tk*.tk_buffer := Malloc(1000);
    if tk*.tk_buffer = nil then
	return;
    fi;
    tk*.tk_bufferLength := 1000;
/*
    tk*.tk_currentChar := ' ';
    tk*.tk_nextChar := ' ';
*/
    LexStandard(tk);

    PrevLine := 1;
    Line := 1;
    PrevColumn := 0;
    Column := 0;
    while
	GetNextToken(tk);
	tk*.tk_kind ~= tk_endOfFile
    do
	case tk*.tk_kind
	incase tk_illegal:
	    err("illegal characters");
	incase tk_ulong:
	    writeln("ULONG: ", tk*.tk_ulongValue);
	incase tk_float:
	    writeln("FLOAT");
	incase tk_string:
	    writeln("STRING \"", tk*.tk_buffer, "\"");
	incase tk_id:
	    writeln("ID ", tk*.tk_buffer);
	incase tk_char:
	    write("CHAR \'");
	    case tk*.tk_charValue
	    incase '\\':
		write("\\\\");
	    incase '\'':
		write("\\\'");
	    incase '\"':
		write("\\\"");
	    incase '\e':
		write("\\e");
	    incase '\t':
		write("\\t");
	    incase '\n':
		write("\\n");
	    incase '\r':
		write("\\r");
	    incase '\b':
		write("\\b");
	    default:
		if tk*.tk_charValue >= ' ' and tk*.tk_charValue <= '~' then
		    write(tk*.tk_charValue);
		else
		    write("\\(0x", tk*.tk_charValue - '\e' : x : -2, ')');
		fi;
	    esac;
	    writeln('\'');
	incase tk_newLine:
	    writeln("NEWLINE");
	incase tk_comment:
	    writeln("COMMENT>>", tk*.tk_buffer, "<<");
	default:
	    write("Token code ", tk*.tk_kind);
/*
	    if tk*.tk_kind >= 100 then
		writeln(" >>>>", ReservedWords[tk*.tk_kind - 100].rw_text,
			"<<<<");
	    elif tk*.tk_kind >= 10 then
		writeln(" >>>>", Operators[tk*.tk_kind - 10].op_text, "<<<<");
	    else
		writeln(" >>>> ???? <<<<");
	    fi;
*/
writeln();
	esac;
    od;

    Mfree(tk*.tk_buffer, tk*.tk_bufferLength);
    CloselexLibrary();
corp;
