#//Lex/Src/Lex.g
#//Common/Types.g
#//Common/Nodes.g
#//Common/NodeTypes.g

#Print.g

/*
 * PrintTree - a standard tree printing routine.
 */

proc PrintTree(register *PrintState_t prs; register *ExpressionNode_t exn)void:
    register *ExpressionNodeList_t exnl;
    register *char p @ exnl;
    register *Construct_t con @ exnl;
    register *Operation_t oper @ exnl;
    register proc(uint token)void printToken @ exnl;
    register proc(uint token)void printToken2 @ exn;
    register proc(char ch)void printChar @ exn;
    register ulong n;
    register uint token @ n;
    register char ch @ n;
    [12] char buffer;
    bool wasComment;

    if exn ~= nil then
	case exn*.exn_kind
	incase exk_prefix:
	    oper := exn*.exn_.exu_un.exu_operation;
	    if oper ~= nil then
		/* allow for the conversion nodes */
		token := con*.con_token;
		printToken := prs*.prs_printToken;
		if printToken ~= nil then
		    printToken(token);
		else
		    PrintToken(prs, token);
		fi;
	    fi;
	    PrintTree(prs, exn*.exn_.exu_un.exu_operand);
	incase exk_postfix:
	    PrintTree(prs, exn*.exn_.exu_un.exu_operand);
	    token := exn*.exn_.exu_un.exu_operation*.oper_token;
	    printToken := prs*.prs_printToken;
	    if printToken ~= nil then
		printToken(token);
	    else
		PrintToken(prs, token);
	    fi;
	incase exk_binary:
	    PrintTree(prs, exn*.exn_.exu_bi.exb_left);
	    prs*.prs_space();
	    token := exn*.exn_.exu_bi.exb_operation*.oper_token;
	    printToken := prs*.prs_printToken;
	    if printToken ~= nil then
		printToken(token);
	    else
		PrintToken(prs, token);
	    fi;
	    prs*.prs_space();
	    PrintTree(prs, exn*.exn_.exu_bi.exb_right);
	incase exk_special:
	    exn*.exn_.exu_con.exc_construct*.con_printer(prs, exn);
	incase exk_string:
	    prs*.prs_putChar('\"');
	    n := exn*.exn_.exu_string.exs_length;
	    p := exn*.exn_.exu_string.exs_string;
	    printChar := prs*.prs_printChar;
	    if printChar ~= nil then
		while n > 1 do
		    n := n - 1;
		    printChar(p*);
		    p := p + sizeof(char);
		od;
	    else
		while n > 1 do
		    n := n - 1;
		    PrintChar(prs, p*);
		    p := p + sizeof(char);
		od;
	    fi;
	    prs*.prs_putChar('\"');
	incase exk_id:
	    prs*.prs_printSymbol(exn*.exn_.exu_id);
	incase exk_ulong:
	    n := exn*.exn_.exu_ulong;
	    p := &buffer[11];
	    p* := '\e';
	    while
		p := p - sizeof(char);
		p* := n % 10 + '0';
		n := n / 10;
		n ~= 0
	    do
	    od;
	    prs*.prs_putString(p);
	incase exk_float:
	    prs*.prs_putString("<FLOAT>");
	incase exk_char:
	    prs*.prs_putChar('\'');
	    ch := exn*.exn_.exu_char;
	    printChar := prs*.prs_printChar;
	    if printChar ~= nil then
		printChar(ch);
	    else
		PrintChar(prs, ch);
	    fi;
	    prs*.prs_putChar('\'');
	incase exk_list:
	    exnl := exn*.exn_.exu_list;
	    printToken2 := prs*.prs_printToken;
	    while exnl ~= nil do
		if exnl*.exnl_this ~= nil then
		    PrintTree(prs, exnl*.exnl_this);
		    wasComment := exnl*.exnl_this*.exn_kind = exk_comment;
		    exnl := exnl*.exnl_next;
		    if exnl ~= nil then
			if not wasComment then
			    if printToken2 ~= nil then
				printToken2(tk_semicolon);
			    else
				PrintToken(prs, tk_semicolon);
			    fi;
			fi;
			if exnl*.exnl_this ~= nil then
			    prs*.prs_newLine();
			fi;
		    fi;
		else
		    exnl := exnl*.exnl_next;
		fi;
	    od;
	incase exk_comment:
	    prs*.prs_putString(exn*.exn_.exu_string.exs_string);
	incase exk_paren:
	    exn := exn*.exn_.exu_paren;
	    printToken := prs*.prs_printToken;
	    if printToken ~= nil then
		printToken(tk_openParen);
		PrintTree(prs, exn);
		printToken(tk_closeParen);
	    else
		PrintToken(prs, tk_openParen);
		PrintTree(prs, exn);
		PrintToken(prs, tk_closeParen);
	    fi;
	incase exk_error:
	    prs*.prs_putString("<ERROR>");
	esac;
    else
	prs*.prs_putString("<nil>");
    fi;
corp;
