#Print.g
#//Lex/Src/Lex.g

/*
 * PrintToken - print an arbitrary token. Assumes the standard tokenizer
 *	data structure is pointed to by the prs structure.
 */

proc PrintToken(register *PrintState_t prs; register uint token)void:
    register *TokenizerState_t tk;
    register *ReservedWord_t rw;
    register *Operator_t op @ rw;
    register proc(char ch)void putChar @ tk;
    register uint count;

    tk := prs*.prs_tk;
    if tk ~= nil then
	rw := tk*.tk_reservedWords;
	count := tk*.tk_reservedWordCount;
	while count ~= 0 and rw*.rw_code ~= token do
	    count := count - 1;
	    rw := rw + sizeof(ReservedWord_t);
	od;
	if count ~= 0 then
	    prs*.prs_putString(rw*.rw_text);
	    return;
	fi;
	op := tk*.tk_operators;
	count := tk*.tk_operatorCount;
	while count ~= 0 and op*.op_code ~= token do
	    count := count - 1;
	    op := op + sizeof(Operator_t);
	od;
	if count ~= 0 then
	    putChar := prs*.prs_putChar;
	    putChar(op*.op_text[0]);
	    if op*.op_text[1] ~= ' ' then
		putChar(op*.op_text[1]);
	    fi;
	    return;
	fi;
	prs*.prs_putString("???");
    fi;
corp;

/*
 * PrintChar - print a character in a string or character constants.
 *	Assumes the standard tokenizer data structure is pointed to by the
 *	prs structure.
 */

proc PrintChar(register *PrintState_t prs; register char ch)void:
    register *TokenizerState_t tk;
    register proc(char ch)void putChar;
    register char stringEscape;
    register byte digit @ stringEscape;

    tk := prs*.prs_tk;
    if tk ~= nil then
	putChar := prs*.prs_putChar;
	stringEscape := tk*.tk_stringEscape;
	if ch = '\e' then
	    putChar(stringEscape);
	    putChar('e');
	elif ch = '\t' then
	    putChar(stringEscape);
	    putChar('t');
	elif ch = '\n' then
	    putChar(stringEscape);
	    putChar('n');
	elif ch = '\r' then
	    putChar(stringEscape);
	    putChar('r');
	elif ch = '\b' then
	    putChar(stringEscape);
	    putChar('b');
	elif tk*.tk_characterClass[ch] = cc_string or
	    tk*.tk_characterClass[ch] = cc_char
	then
	    putChar(stringEscape);
	    putChar(ch);
	elif ch < ' ' or ch > '~' and tk*.tk_characterClass[ch] = cc_illegal
	then
	    putChar(stringEscape);
	    putChar('(');
	    putChar('0');
	    putChar('x');
	    digit := (ch - '\e');
	    digit := digit >> 4;
	    putChar(if digit > 10 then digit + ('a' - 10) else digit + '0' fi);
	    digit := (ch - '\e');
	    digit := digit & 0xf;
	    putChar(if digit > 10 then digit + ('a' - 10) else digit + '0' fi);
	    putChar(')');
	else
	    putChar(ch);
	fi;
    fi;
corp;
