#Symbol.g
#drinc:util.g

proc myAlloc(ulong length)arbptr:

    Malloc(length)
corp;

proc myFree(arbptr p; ulong length)void:

    Mfree(p, length);
corp;

proc myDelete(*Symbol_t sy)void:

    writeln("myDelete(", sy*.sy_name, ")");
corp;

proc main()void:
    register *SymbolTable_t syt;
    register *Symbol_t sy;
    SymbolState_t sym;
    register ulong size;
    char cmd;
    [50] char name;

    sym.sym_alloc := myAlloc;
    sym.sym_free := myFree;
    sym.sym_hashFunction := sy_simpleHash;
    sym.sym_deleteFunction := myDelete;

    syt := nil;
    while
	write("> ");
	read(cmd) and cmd ~= 'q'
    do
	case cmd
	incase '?':
	    writeln("Commands are:");
	    writeln("    q - quit");
	    writeln("    c <n> - create new table, size n");
	    writeln("    k - destroy table");
	    writeln("    e <name> - enter name into table");
	    writeln("    l <name> - look name up in table");
	    writeln("    d <name> - delete name from table");
	    writeln("    f - flush the table of all entries");
	    writeln("    s - scan the table");
	incase 'c':
	    if syt ~= nil then
		writeln("*** table already exists");
	    elif read(size) then
		syt := sy_create(&sym, size);
		if syt = nil then
		    writeln("*** create failed");
		else
		    writeln("create succeeded");
		fi;
	    else
		writeln("*** bad size");
		ignore ioerror();
	    fi;
	incase 'k':
	    if syt = nil then
		writeln("*** no table yet");
	    else
		sy_destroy(&sym, syt);
		syt := nil;
		writeln("table destroyed");
	    fi;
	incase 'e':
	    if syt = nil then
		writeln("*** no table yet");
	    elif read(&name[0]) then
		sy := sy_enter(&sym, syt, &name[0], CharsLen(&name[0]) + 1);
		if sy = nil then
		    writeln("*** can't enter symbol!");
		elif sy*.sy_kind ~= syk_entered then
		    writeln("*** symbol '", &name[0], "' already in table");
		else
		    sy*.sy_kind := 10;
		    writeln('\'', &name[0], "' entered at 0x", sy);
		fi;
	    else
		writeln("*** bad name");
		ignore ioerror();
	    fi;
	incase 'l':
	    if syt = nil then
		writeln("*** no table yet");
	    elif read(&name[0]) then
		sy := sy_lookup(&sym, syt, &name[0], CharsLen(&name[0]) + 1);
		if sy = nil then
		    writeln("symbol '", &name[0], "' not found");
		else
		    writeln("symbol '", &name[0], "' found");
		fi;
	    else
		writeln("*** bad name");
		ignore ioerror();
	    fi;
	incase 'd':
	    if syt = nil then
		writeln("*** no table yet");
	    elif read(&name[0]) then
		sy_delete(&sym, syt, &name[0], CharsLen(&name[0]) + 1);
		writeln("symbol '", &name[0], "' deleted");
	    else
		writeln("*** bad name");
		ignore ioerror();
	    fi;
	incase 'f':
	    if syt = nil then
		writeln("*** no table yet");
	    else
		sy_empty(&sym, syt);
		writeln("table flushed");
	    fi;
	incase 's':
	    if syt = nil then
		writeln("*** no table yet");
	    else
		writeln("Entries in table (", syt*.syt_usedCount,
			" out of ", syt*.syt_entryCount, " used:");
		sy := syt*.syt_entries;
		size := syt*.syt_entryCount;
		while size ~= 0 do
		    size := size - 1;
		    write("    0x", sy, ' ');
		    case sy*.sy_kind
		    incase syk_empty:
			writeln("<empty slot>");
		    incase syk_free:
			writeln("<free slot>");
		    incase syk_entered:
			writeln("<entered: ", sy*.sy_name, '>');
		    default:
			writeln(sy*.sy_name);
		    esac;
		    sy := sy + sizeof(Symbol_t);
		od;
	    fi;
	default:
	    writeln("*** unknown command, see '?' for help");
	esac;
	readln();
    od;
    if syt ~= nil then
	sy_destroy(&sym, syt);
    fi;
corp;
