type
    Symbol_t = struct {
	uint sy_kind;		/* see below, or an application-defined one */
	ulong sy_nameLen;	/* length in bytes of name - including \e */
	ulong sy_hash;		/* hash function value of name */
	*char sy_name;		/* pointer to buffer holding the name */
	union { 		/* application-specific type info */
	    ulong syu_typeNo;	/* a simple type number */
	    *Type_t syu_typePtr;/* pointer to a more complex description */
	} sy_type;
	union { 		/* application-specific value */
	    char syu_char;
	    uint syu_uint;
	    ulong syu_ulong;
	    float syu_float;
	    *char syu_string;
	    arbptr syu_arb;
	} sy_value;
    },

    SymbolTable_t = struct {
	ulong syt_entryCount;	/* number of actual entries in table */
	ulong syt_usedCount;	/* number of entries in use now */
	*Symbol_t syt_entries;	/* pointer to actual entry array */
    },

    SymbolState_t = struct {
	proc(ulong length)arbptr sym_alloc;
	proc(arbptr p; ulong length)void sym_free;
	proc(*char name; ulong nameLength)ulong sym_hashFunction;
	proc(*Symbol_t sy)void sym_deleteFunction;
    };

uint
    syk_empty	= 0,	/* never been used */
    syk_free	= 1,	/* been used, but now free */
    syk_entered = 2,	/* we have entered it - user has not changed kind */

    /* these are here for the convenience of any user - they are not used
       internal to this library */

    syk_globalVariable	= 10,
    syk_fileVariable	= syk_globalVariable + 1,
    syk_localVariable	= syk_fileVariable + 1,
    syk_modulePublic	= syk_localVariable + 1,
    syk_modulePrivate	= syk_modulePublic + 1,
    syk_parameter	= syk_modulePrivate + 1,
    syk_systemVar	= syk_parameter + 1,
    syk_ROSystemVar	= syk_systemVar + 1,
    syk_absoluteVar	= syk_ROSystemVar + 1,
    syk_externVar	= syk_absoluteVar + 1,
    syk_constant	= syk_externVar + 1,
    syk_publicProc	= syk_constant + 1,
    syk_privateProc	= syk_publicProc + 1,
    syk_absoluteProc	= syk_privateProc + 1,
    syk_externProc	= syk_absoluteProc + 1,
    syk_fieldName	= syk_externProc+ 1,
    syk_enumMember	= syk_fieldName+ 1,
    syk_typeName	= syk_enumMember + 1;

extern
    sy_create(*SymbolState_t sym; ulong entryCount)*SymbolTable_t,
    sy_destroy(*SymbolState_t sym; *SymbolTable_t syt)void,
    sy_empty(*SymbolState_t sym; *SymbolTable_t syt)void,
    sy_enter(*SymbolState_t sym; *SymbolTable_t syt;
	     *char name; ulong nameLen)*Symbol_t,
    sy_lookup(*SymbolState_t sym; *SymbolTable_t syt;
	      *char name; ulong nameLen)*Symbol_t,
    sy_delete(*SymbolState_t sym; *SymbolTable_t syt;
	      *char name; ulong nameLen)void,
    sy_simpleHash(*char name; ulong nameLen)ulong;
