#patternInternal.g

/*
 * Compile - external interface to the internal routine. This interface
 *	saves the register that is used as a file global in 'compile.d'
 *	and gets the passed parameter into an accessible place.
 */

proc Compile(/* register *PatternState_t ps(A0) */)void:
    uint
	R_A0 = 0,
	R_FP = 6,
	OP_MOVEL = 0x2000,
	M_ADIR = 1,
	M_DISP = 5;
    register *char registerToSaveTheGlobal;
    *PatternState_t ps;

    /* This peculiar looking stuff is generating a move instruction to take
       the value from register A0, and put it into local variable
       'patternState'. This handles the special register linkage used for
       library entry points in AmigaDOS. See the Draco documentation for
       details on the 'code' construct. */

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_ADIR << 3 | R_A0,
	ps
    );
    internalCompile(ps);
corp;

/*
 * Match - interface, as above, to the Match entry point.
 */

proc Match(/* register *PatternState_t ps(A0);
	      *char subject(A1); ulong subjectLength(D0) */)bool:
    uint
	R_A0 = 0,
	R_A1 = 1,
	R_D0 = 0,
	R_FP = 6,
	OP_MOVEL = 0x2000,
	M_DDIR = 0,
	M_ADIR = 1,
	M_DISP = 5;
    register *char registerToSaveTheGlobal;
    *PatternState_t ps;
    *char subject;
    ulong subjectLength;

    /* Inline code to access the parameters passed in registers. */

    code(
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_ADIR << 3 | R_A0,
	ps,
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_ADIR << 3 | R_A1,
	subject,
	OP_MOVEL | R_FP << 9 | M_DISP << 6 | M_DDIR << 3 | R_D0,
	subjectLength
    );
    internalMatch(ps, subject, subjectLength)
corp;
