#drinc:exec/miscellaneous.g
#drinc:exec/nodes.g
#drinc:exec/lists.g
#drinc:exec/libraries.g
#drinc:exec/execbase.g
#drinc:exec/tasks.g
#drinc:libraries/dos.g
#drinc:util.g

uint
    ID_MAX = 100,			/* space for library id */
    LIB_MAX = 100;			/* how many libraries */

[LIB_MAX][ID_MAX] char Names;

proc message(*char m)void:
    register *char p;

    p := m;
    while p* ~= '\e' do
	p := p + sizeof(char);
    od;
    ignore Write(Output(), m, p - m);
corp;

proc listList(*char what; *List_t lh)void:
    register *Node_t ln;
    register *char p, q;
    register uint i, len;

    message(what);
    message(":\n");
    i := 0;
    Forbid();
    ln := lh*.lh_Head;
    while ln*.ln_Succ ~= nil do
	p := &Names[i][0];
	if ln*.ln_Name = nil then
	    q := "<nil>";
	else
	    q := ln*.ln_Name;
	fi;
	len := ID_MAX - 1;
	while q* ~= '\e' and len ~= 0 do
	    p* := q*;
	    p := p + sizeof(char);
	    q := q + sizeof(char);
	    len := len - 1;
	od;
	p* := '\e';
	ln := ln*.ln_Succ;
	i := i + 1;
    od;
    Permit();
    while i ~= 0 do
	i := i - 1;
	message("    ");
	message(&Names[i][0]);
	message("\n");
    od;
corp;

proc listAllLists(register *ExecBase_t eb)void:
    register proc(*char what; *List_t lh)void r_listList;

    r_listList := listList;
    r_listList("Mem", &eb*.eb_MemList);
    r_listList("Resource", &eb*.eb_ResourceList);
    r_listList("Device", &eb*.eb_DeviceList);
    r_listList("Intr", &eb*.eb_IntrList);
    r_listList("Lib", &eb*.eb_LibList);
    r_listList("Port", &eb*.eb_PortList);
    r_listList("TaskReady", &eb*.eb_TaskReady);
    r_listList("TaskWait", &eb*.eb_TaskWait);
    r_listList("Semaphore", &eb*.eb_SemaphoreList);
corp;

proc main()void:
    *char USE = "Use is: expunge {-mrdilpts* | <exact-library-name>}\n";
    uint
	R_A0 = 0,
	R_A5 = 5,
	R_LIB = 6,
	R_FP = 6,

	M_ADIR = 1,
	M_INDIR = 2,
	M_DISP = 5,

	OP_MOVEL = 0x2000,
	OP_JSR = 0x4e80;
    extern
	GetPars(*ulong pLen; **char pPtr)void;
    register *char unusedARegWhichWillBeA5;
    ulong parLen;
    *char parPtr, name;
    *Library_t lib;
    register *char p;
    register *ExecBase_t eb;
    proc()void expungeEntry;
    register proc(*char what; *List_t lh)void r_listList;
    register proc(*char str)void r_message @ r_listList;

    if OpenDosLibrary(0) ~= nil then
	eb := OpenExecLibrary(0);
	if eb ~= nil then
	    GetPars(&parLen, &parPtr);
	    p := parPtr;
	    while p* = ' ' or p* = '\t' do
		p := p + sizeof(char);
	    od;
	    if p* = '\r' or p* = '\n' or p* = '\e' then
		message(USE);
	    elif p* = '-' then
		p := p + sizeof(char);
		r_listList := listList;
		while p* ~= '\e' and p* ~= '\r' and p* ~= '\n' and p* ~= '\t'
		do
		    case p*
		    incase 'm':
		    incase 'M':
			r_listList("Mem", &eb*.eb_MemList);
		    incase 'r':
		    incase 'R':
			r_listList("Resource", &eb*.eb_ResourceList);
		    incase 'd':
		    incase 'D':
			r_listList("Device", &eb*.eb_DeviceList);
		    incase 'i':
		    incase 'I':
			r_listList("Intr", &eb*.eb_IntrList);
		    incase 'l':
		    incase 'L':
			r_listList("Lib", &eb*.eb_LibList);
		    incase 'p':
		    incase 'P':
			r_listList("Port", &eb*.eb_PortList);
		    incase 't':
		    incase 'T':
			r_listList("TaskReady", &eb*.eb_TaskReady);
			r_listList("TaskWait", &eb*.eb_TaskWait);
		    incase 's':
		    incase 'S':
			r_listList("Semaphore", &eb*.eb_SemaphoreList);
		    incase '*':
			listAllLists(eb);
		    default:
			message(USE);
		    esac;
		    p := p + sizeof(char);
		od;
	    else
		name := p;
		while p* ~= ' ' and p* ~= '\t' and p* ~= '\r' and
		    p* ~= '\n' and p* ~= '\e'
		do
		    p := p + sizeof(char);
		od;
		p* := '\e';
		r_message := message;
		if FindName(&eb*.eb_LibList, name) = nil then
		    r_message("Library '");
		    r_message(name);
		    r_message("' is not currently open\n");
		else
		    /* use OpenLibrary to avoid it going away on us */
		    lib := OpenLibrary(name, 0);
		    if lib ~= nil then
			r_message("Opened library '");
			r_message(name);
			r_message("'\n");
			expungeEntry := pretend(lib + LIB_EXPUNGE, proc()void);
			if expungeEntry = nil then
			    r_message("Library '");
			    r_message(name);
			    r_message("' has no expunge entry.\n");
			else
			    code(
				OP_MOVEL | R_A0 << 9 | M_ADIR << 6 |
				    M_DISP << 3 | R_FP,
				expungeEntry,
				OP_MOVEL | R_A5 << 9 | M_ADIR << 6 |
				    M_ADIR << 3 | R_FP,
				OP_MOVEL | R_LIB << 9 | M_ADIR << 6 |
				    M_DISP << 3 | R_FP,
				lib,
				OP_JSR | M_INDIR << 3 | R_A0,
				OP_MOVEL | R_FP << 9 | M_ADIR << 6 |
				    M_ADIR << 3 | R_A5
			    );
			    r_message("Requested expunge of library '");
			    r_message(name);
			    r_message("'\n");
			fi;
			CloseLibrary(lib);
		    else
			r_message("Could not open library '");
			r_message(name);
			r_message("'\n");
		    fi;
		fi;
	    fi;
	    CloseExecLibrary();
	fi;
	CloseDosLibrary();
    fi;
corp;
